#include <Arduino_GFX_Library.h>
#include <Arduino.h>
#include "hardware/adc.h"
#include <hardware/rtc.h>
#include <time.h>
#include "Wire.h"              // I2C'yi kullanan dahili kütüphaneyi ekliyoruz
#include <Adafruit_MPU6050.h>


Adafruit_MPU6050 mpu;
Arduino_DataBus *bus = new Arduino_RPiPicoSPI(8 /* DC */, 9 /* CS */, 10 /* SCK */, 11 /* MOSI */, 12 /* MISO */, spi1 /* spi */);
Arduino_GFX *gfx = new Arduino_GC9A01(bus, 28 /* RST */, 0 /* rotation */, true /* IPS */, 240 /* width */, 240 /* height */);

// İkinci ekran tanımlamaları
Arduino_DataBus *bus2 = new Arduino_RPiPicoSPI(12 /* DC */, 14 /* CS */, 10 /* SCK */, 11 /* MOSI */, 17 /* MISO */, spi1 /* spi */);
Arduino_GFX *gfx2 = new Arduino_GC9A01(bus2, 29 /* RST */, 0 /* rotation */, true /* IPS */, 240 /* width */, 240 /* height */);

/* More dev device declaration: https://github.com/moononournation/Arduino_GFX/wiki/Dev-Device-Declaration */

/*******************************************************************************
 * End of Arduino_GFX setting
 ******************************************************************************/
 
int sespin = 26;// GPIO26ADC pinini sensör pini olarak tanımla
int sesValue = 0;  // Sensör değerini saklamak için değişken
int hata, adres, cihaz_sayisi; // Değişkenlerimizi tanımlıyoruz
datetime_t t; 
unsigned long pMilliss = 0; //millis for i2cscan
unsigned long pMillism = 0; //millis for MPU 
unsigned long pMillise = 0; //millis for eyes 
int taskno;
int taskCounter;

// Set I2C bus to use: Wire, Wire1, etc.
#define WIRE Wire
#define NUM_CIRCLES 10 // Ekolizer için daire sayısı

void setup(void)
{
#ifdef DEV_DEVICE_INIT
  DEV_DEVICE_INIT();
#endif
Wire.begin();
 if (!mpu.begin()) {
    Serial.println("MPU6050 başlatılamadı!");
    while (1);
  }
 // RTC'yi başlat
  rtc_init();

pinMode(sespin, INPUT);

  // Tarih ve saat değerlerini ayarla
  datetime_t t = {
    .year = 2025,
    .month = 2,
    .day = 15,
    .dotw = 6, // Day of the week: 0 = Sunday, 1 = Monday, ..., 6 = Saturday
    .hour = 19,
    .min = 43,
    .sec = 0
  };

  // RTC'ye yeni tarih ve saat değerlerini ayarla
   rtc_set_datetime(&t);

  
//DAHİLİ ISI SENDÖR internal heat sensor
adc_init();
  adc_set_temp_sensor_enabled(true);
  adc_select_input(4); // 4. ADC kanalını seçin



 Serial.begin(115200); // Seri iletişim başlat
 

  // Init Display
  if (!gfx->begin())
  {
    Serial.println("gfx->begin() failed!");
  }
  if (!gfx2->begin())
  {
    Serial.println("gfx2->begin() failed!");
  }
  gfx->fillScreen(RGB565_WHITE);
  gfx2->fillScreen(RGB565_WHITE);


gozciz (1,90,-1,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk
gozciz (2,90,-1,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk
gozciz (1,90,-1,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk
gozciz (2,90,-1,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk
delay(400);
gkapakciz(80);
  delay(5000); // 5 seconds
  gfx->fillScreen(RGB565_WHITE);
  gfx2->fillScreen(RGB565_WHITE);
gozciz (1,80,-1,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk
gozciz (2,80,-1,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk



 
}

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
void loop(){

//read values from sensors
sesValue = digitalRead(sespin); //read sound sensor
float temperature = readTemperature() ; // Sıcaklık değeri
rtc_get_datetime(&t); // RTC'den mevcut tarih ve saat değerlerini oku
    sensors_event_t a, g, temp;
    mpu.getEvent(&a, &g, &temp);
    float angle = atan2(a.acceleration.x, a.acceleration.y) * 360 / PI; //calc angle
unsigned long cMillis = millis(); //current time

 //DEMO
 /*random eyes, 
 when sound sendor aktive next task
 100 turn mpu
10 turn i2cscan and clock
return start
*/

  if (sesValue == 0) { 
  taskno = taskno + 1;
  Serial.println(taskno);
   gfx->fillScreen(RGB565_WHITE);
    gfx2->fillScreen(RGB565_WHITE);
gozciz (1,40,-1,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk
gozciz (2,90,-1,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk
  }

if (taskno == 0){
  
if (cMillis - pMillise >= 8000) { //every 8sn
    pMillise = cMillis; 
    gfx->fillScreen(RGB565_WHITE);
    gfx2->fillScreen(RGB565_WHITE);
    randomeyes();
}
}
  
 if (taskno  == 1) {
if (cMillis - pMillism >= 10) { 
    pMillism = cMillis; 
    suterazi(angle);
    drawTemperatureGauge(gfx2, temperature); //gfx1 or gfx2 display and temp value
    taskCounter ++;
    Serial.println(taskCounter);
   if (taskCounter == 100){
    taskno= 2;   
    taskCounter=0;
    }
   }
 }

 if (taskno  == 2) {
if (cMillis - pMillise >= 1000) { 
    pMillise = cMillis; 
    i2cscan();
    saatgosterge();
    taskCounter ++;
    Serial.println(taskCounter);
   if (taskCounter == 5){ //run 5 turn
    taskno= 0;   
    taskCounter=0;
    }
   }
 }
 

}


void suterazi(int angle){
  
 
  gfx->fillScreen(BLACK);

  // Açıya bağlı olarak çapraz bir çizgi çizin
  int x_center = gfx->width() / 2;
  int y_center = gfx->height() / 2;
  int length = 50; // Çizginin uzunluğu
  
  // Çizginin uç noktalarını hesaplayın
  int x1 = x_center - length * cos(angle * PI / 180.0);
  int y1 = y_center - length * sin(angle * PI / 180.0);
  int x2 = x_center + length * cos(angle * PI / 180.0);
  int y2 = y_center + length * sin(angle * PI / 180.0);

  gfx->drawLine(x1, y1, x2, y2, WHITE);
  delay(50);
}


void i2cscan(){
 //clear screens
    gfx2->fillScreen(RGB565_BLACK);
byte error, address;
  int nDevices;
    gfx2->setCursor(60, 60);
    gfx2->setTextSize(2);
    gfx2->setTextColor(RGB565_RED);
   
    gfx2->println("Scanning...");

  nDevices = 0;
  for(address = 1; address < 127; address++ )
  {
    // The i2c_scanner uses the return value of
    // the Write.endTransmisstion to see if
    // a device did acknowledge to the address.
    WIRE.beginTransmission(address);
    error = WIRE.endTransmission();

    if (error == 0)
    {
    gfx2->setTextColor(RGB565_GREEN);
    gfx2->println("I2C device found");
      if (address<16)
      gfx2->print(".....0x");
      gfx2->print(address,HEX);
      gfx2->println("!");

      nDevices++;
    }
    else if (error==4)
    {
      Serial.print("Unknown error at address 0x");
      if (address<16)
        Serial.print("0");
      Serial.println(address,HEX);
    }
  }
  if (nDevices == 0)

    gfx2->println("No I2C");
  else
    Serial.println("done\n");

  delay(4000);           // wait 5 seconds for next scan

}

void gkapakciz(int y)
{
gfx->fillRect(0, 0, 240, y, 0x8410);
gfx2->fillRect(0, 0, 240, y, 0x8410);
}

void gozciz(int goz,int boyut, int aci, int renk){
int beyaz=100;
int kx = 120 ;
int ky = 120 ;
//mavi,siyah merkez bulma -1 sa orta

if (aci != -1){
 kx = (120 + (beyaz-boyut) * cos(aci * (PI / 180.0)));
 ky = 120 - (beyaz-boyut) *  sin(aci * (PI / 180.0));
}
//parıltı merkezi
int x = kx + boyut * sqrt(2) / 2;
  int y = ky - boyut * sqrt(2) / 2;

if (goz==1) //sol
{ 
// Sol gözü çiz
  gfx->fillCircle(120, 120, beyaz, RGB565_WHITE); // Gözün beyaz kısmı
  gfx->fillCircle(kx, ky, boyut, renk);  // Mavi iris
  gfx->fillCircle(kx, ky, boyut-20, RGB565_BLACK); // Siyah pupil
  gfx->fillCircle(x-30, y+30, (boyut-20)/10, RGB565_WHITE); // Beyaz parıltı

}else{ //sag
gfx2->fillCircle(120, 120, beyaz, RGB565_WHITE); // Gözün beyaz kısmı
  gfx2->fillCircle(kx, ky, boyut, renk);  // Mavi iris
  gfx2->fillCircle(kx, ky, boyut-20, RGB565_BLACK); // Siyah pupil
  gfx2->fillCircle(x-30, y+30, (boyut-20)/10, RGB565_WHITE); // Beyaz parıltı

}
}

float readTemperature() {
  uint16_t raw = adc_read();
  const float conversion_factor = 3.3f / (1 << 12);
  float result = raw * conversion_factor;
  float temp = 27 - (result - 0.706) / 0.001721;
  return temp;
}


void drawTemperatureGauge(Arduino_GFX *gfx, float temperature) {
   //clear screens
  gfx->fillScreen(RGB565_BLACK);
  
  int centerX = 120; // Ekranın merkez X koordinatı (240/2)
  int centerY = 120; // Ekranın merkez Y koordinatı (240/2)
  int radius = 100;  // Gösterge yarıçapı

  // Göstergeyi temizle
  gfx->fillCircle(centerX, centerY, radius, BLACK);

  // Dış çemberi çiz
  gfx->drawCircle(centerX, centerY, radius, WHITE);

  // Sıcaklık değerini açıya çevir
  float angle = map(temperature, -10, 40, 0, 360);

  // Göstergeyi çiz
  int endX = centerX + radius * cos(radians(angle));
  int endY = centerY + radius * sin(radians(angle));
  gfx->drawLine(centerX, centerY, endX, endY, ORANGE);

  // Sıcaklık değerini yazdır
  gfx->setCursor(centerX - 35, centerY - 25);
  gfx->setTextSize(3);
  gfx->setTextColor(WHITE);
  gfx->print(temperature, 1);
  gfx->print(" C");
}

void saatgosterge(){
  
  // Tarih ve saat değerlerini seri port üzerinden yazdır
  //Serial.printf("Tarih: %02d/%02d/%04d Saat: %02d:%02d:%02d\n", t.day, t.month, t.year, t.hour, t.min, t.sec);

gfx->fillScreen(BLACK);
      gfx->setCursor(55, 100);
      gfx->setTextColor(BLUE);
      gfx->setTextSize(6);

      // Tarih ve saat formatında gösterim
  //gfx->printf("%02d/%02d/%04d %02d:%02d:%02d", t.day, t.month, t.year, t.hour, t.min, t.sec); //full time info
  gfx->printf("%02d:%02d", t.hour, t.min); //hour and minute only
  
}



  void ekolizer(){
  int micValue = analogRead(sespin);//need another sound sensor
  int radius = map(micValue, 1023, 0, 0, gfx->height() / 2);

  gfx->fillScreen(BLACK);
  for (int i = 0; i < NUM_CIRCLES; i++) {
    int color = gfx->color565(255 - i * 25, i * 25, 255 - i * 25); // Renk oluşturma
    gfx->fillCircle(gfx->width() / 2, gfx->height() / 2, radius / (i + 1), color);
  }

  }


void randomeyes(){
 
  int ranboyut = random(40, 80);
  int ranaci = random(0, 360);
gozciz (1,ranboyut,ranaci,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk
gozciz (2,ranboyut,ranaci,RGB565_BLUE); //sag/sol goz,boyut, konum açı,renk

  }
   

